# Startup script for the myth server
# starts up userd, then starts up one roomd for
# each room listed in the rooms.lst file
#
# Jeff Sheltren <sheltren@cs.ucsb.edu>
# Nov 04 2003

###############################################
# CONFIG - change these values as needed
MYTHDIR='.'
BINDIR=${MYTHDIR}/bin
ROOMS_LIST=${MYTHDIR}/rooms.lst
USERD='userd_new'
ROOMD='roomd_new'
# END CONFIG
##############################################

if [ ! -x ${BINDIR}/${USERD} ]
then
    echo "Error: userd binary is missing or not executable!"
    exit 1
fi

if [ ! -x ${BINDIR}/${ROOMD} ]
then
    echo "Error: roomd binary is missing or not executable!"
    exit 1
fi

if [ ! -r $ROOMS_LIST ]
then
    echo "Error: rooms list is not readable!"
    exit 1
fi

num_rooms=`grep -c "" rooms.lst`
if [ $num_rooms -lt 1 ]
then
    echo "Error: no rooms found in room list!"
    exit 1
fi


# everything seems OK, go ahead with starting things up
echo "Starting the user daemon..."
${BINDIR}/${USERD} &

# start up one roomd for each room we counted
echo "Starting $num_rooms room daemon processes..."
for ((  i = 0 ;  i < num_rooms;  i++  ))
do
    ${BINDIR}/${ROOMD} &
done

echo "Done."

exit
