/*
Part of the Bungie.net Myth2 Metaserver source code
Copyright (c) 1997-2002 Bungie Studios
Refer to the file "License.txt" for details
*/

#ifndef __ENVIRONMENT_H
#define __ENVIRONMENT_H

#ifdef HARDCODE_USERD_SETTINGS
	
	#ifdef RUNNING_LOCALLY
		#warning USERD_HOST set as localhost
		#define USERD_HOST							"127.0.0.1"
	#endif
	
	#ifndef BN2_DEMOVERSION

		#define METASERVER_ROOT_DIR					"./"
		#define MOTD_FILE_NAME						METASERVER_ROOT_DIR"motd"
		#ifndef USERD_HOST
		/*
			#warning USERD_HOST set to 128.111.41.232
		*/
			#define USERD_HOST						"208.186.220.54" // <insert your static ip here>
		#endif
		#define USERD_PORT							"6321"
		#define USERD_ROOM_PORT						"6323"
		#define USERD_WEB_PORT						"6322"
		#define DB_DIRECTORY						METASERVER_ROOT_DIR"db/"
		#define ORDERS_DB_FILE_NAME					DB_DIRECTORY"orders.dat"
		#define USERS_DB_FILE_NAME					DB_DIRECTORY"users.dat"
		#define LOG_DIRECTORY						METASERVER_ROOT_DIR"log/"
		#define ROOMS_LIST_FILE						METASERVER_ROOT_DIR"rooms.lst"
		#define ADMIN_LOG_FILE_NAME					LOG_DIRECTORY"adminlog.txt"
		#define GAMES_LOG_FILE						LOG_DIRECTORY"games_log"
		#define	GUEST_ACCOUNT_NAME					"guest" // only if guest mode is enabled

	#else /* BN2_DEMOVERSION */

        #define METASERVER_ROOT_DIR                 "./"
        #define MOTD_FILE_NAME                      METASERVER_ROOT_DIR"motd"
		#ifndef USERD_HOST
			#warning USERD_HOST set to demo server
			#define USERD_HOST						"208.186.220.54" // <insert your static ip here>
		#endif
		#define USERD_PORT							"6321"
		#define USERD_ROOM_PORT						"6333"
		#define USERD_WEB_PORT						"6332"
		#define DB_DIRECTORY						METASERVER_ROOT_DIR"db/"
		#define ORDERS_DB_FILE_NAME					DB_DIRECTORY"orders.dat"
		#define USERS_DB_FILE_NAME					DB_DIRECTORY"users.dat"
		#define LOG_DIRECTORY						METASERVER_ROOT_DIR"log/"
		#define ROOMS_LIST_FILE						METASERVER_ROOT_DIR"rooms.lst"
		#define ADMIN_LOG_FILE_NAME					LOG_DIRECTORY"adminlog.txt"
		#define GAMES_LOG_FILE						LOG_DIRECTORY"games_log"
		#define	GUEST_ACCOUNT_NAME					"guest"

	#endif
	
	#define get_metaserver_root_dir()				METASERVER_ROOT_DIR
	#define get_motd_file_name()					MOTD_FILE_NAME
	#define get_userd_host()						USERD_HOST
	#define get_userd_port()						USERD_PORT
	#define get_userd_room_port()					USERD_ROOM_PORT
	#define get_userd_web_port()					USERD_WEB_PORT
	#define get_db_directory()						DB_DIRECTORY
	#define get_orders_db_file_name()				ORDERS_DB_FILE_NAME
	#define get_users_db_file_name()				USERS_DB_FILE_NAME
	#define get_log_directory()						LOG_DIRECTORY
	#define get_rooms_list_file()					ROOMS_LIST_FILE
	#define get_admin_log_file_name()				ADMIN_LOG_FILE_NAME

#else

	#define	METASERVER_ROOT_DIR				"METASERVER_ROOT_DIR"
	#define	MOTD_FILE_NAME					"MOTD_FILE_NAME"
	#define	USERD_HOST						"USERD_HOST"
	#define	USERD_PORT						"USERD_PORT"
	#define USERD_ROOM_PORT					"USERD_ROOM_PORT"
	#define USERD_WEB_PORT					"USERD_WEB_PORT"
	#define DB_DIRECTORY					"DB_DIRECTORY"
	#define ORDERS_DB_FILE_NAME				"ORDERS_DB_FILE_NAME"
	#define USERS_DB_FILE_NAME				"USERS_DB_FILE_NAME"
	#define	LOG_DIRECTORY					"LOG_DIRECTORY"
	#define ROOMS_LIST_FILE					"ROOMS_LIST_FILE"
	#define	ADMIN_LOG_FILE_NAME				"ADMIN_LOG_FILE_NAME"
	
	char * get_metaserver_root_dir(void);
	char * get_motd_file_name(void);
	char * get_userd_host(void);
	char * get_userd_port(void);
	char * get_userd_room_port(void);
	char * get_userd_web_port(void);
	char * get_db_directory(void);
	char * get_orders_db_file_name(void);
	char * get_users_db_file_name(void);
	char * get_log_directory(void);
	char * get_rooms_list_file(void);
	char * get_admin_log_file_name(void);

#endif // HARDCODE_USERD_SETTINGS



#endif // __ENVIRONMENT_H
